;
;	Serial ]}Vꃋ[`
;	written by H.Kanemoto.
;
;	PC-8801  N88[hŁAw̃AhXw
;	IԒn܂łAVA|[ggāA菇Ae
;	LXg]iɂjs܂B
;
		ORG	09000h

		JR	main

start_addr:	DB	10h,0		; default = $0010
end_addr:	DB	0,0

main:		DI
		LD	(save_stk),SP
		LD	SP,9100h

		LD	A,(0E6C2h)	; bank select 64K RAM
		OR	02h
		OUT	(31h),A

		LD	HL,0E6C0h	; sio/cmt switch
		LD	A,(HL)
		AND	0CFh
		OR	20h
		OUT	(30h),A
		LD	(HL),A

		LD	HL,usart_dat	; 8251 init
		LD	BC,0621h	; B = counter, C = port
		OTIR

		LD	DE,(start_addr)
		LD	HL,(end_addr)
		SCF			; CY = 0 ɂB
		CCF
		SBC	HL,DE
		INC	HL
		EX	DE,HL		; DE = ]oCg
		PUSH	HL		; IX = ]JnAhX
		POP	IX

		LD	B,10h
loop:		LD	A,(IX+00h)	; ]f[^ǂݍ
		PUSH	AF
		SRL	A		; ʂSbit
		SRL	A
		SRL	A
		SRL	A
		CALL	transfer
		POP	AF
		AND	0fh		; ʂSbit
		CALL	transfer
		DEC	B		; s 16byte H
		JR	NZ,next_char
		CALL	send_cr
		LD	B,10h
next_char:	INC	IX		; ++ ]AhX
		DEC	DE		; -- ]JEg
		LD	A,D
		AND	A
		JR	NZ,loop
		LD	A,E
		AND	A
		JR	NZ,loop

		LD	A,(0E6C2h)	; bank restore
		OUT	(31h),A
		LD	SP,(save_stk)
		EI
		RST	38H		; return to monitor (break point)

transfer:	LD	HL,table	; ɕϊ
		ADD	A,L
		LD	L,A
		LD	A,(HL)
		CALL	send_data	; M
		RET

send_cr:	LD	A,0dh		; sR[ho
		CALL	send_data
		LD	A,0ah
		CALL	send_data
		RET

send_data:	PUSH	AF
wait:		IN	A,(21h)		; USART M Ready?
		RRCA
		JR	NC,wait
		POP	AF
		OUT	(20h),A
		RET

usart_dat:	DB	0,0,0,40h,4Eh,31h
table:		DB	'0123456789ABCDEF'
save_stk:	DB	0,0

		END
