/*
 *      PC-8001 HEX to BIN Ver1.00
 *      written by H.Kanemoto, Sep,3,1994.
 *
 *      This is a free software. You may copy or distribute
 *      it without any permissions. But there are NO WARRANTY
 *      of use. Entire risk of use is with you.
 *
 *      usage:  hex2bin.exe filename
 *              filename.hex to filename.cmt
 *
 *      :   hex ASCII  ̧  ޲̧ ɕϊ
 *
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#define  elif  else if
enum HLFLAG {HIGHER, LOWER};

void
main (int argc, char *argv[])
{
    FILE  *s, *d;
    char  name[16];
    int   dat, flag;

    if (argc != 2)
      {
        fprintf (stderr, "usage:hex2bin fname\n");
        return;
      }
    (void) strcpy (name, argv[1]);
    (void) strcat (name, ".hex");
    if ((s=fopen (name,"rb")) == NULL)
      {
        fprintf (stderr, "can't open file %s\n", name);
        return;
      }
    (void) strcpy (name, argv[1]);
    (void) strcat (name, ".cmt");
    if ((d=fopen (name,"wb")) == NULL)
      {
        fprintf (stderr, "can't open file %s\n", name);
        (void) fclose (s);
        return;
      }
    for (flag = HIGHER; !feof (s);)
      {
        int  c = fgetc (s);

        if (isdigit (c))
          c &= 0x0f;
        elif (isxdigit (c))
          c -= 0x37;
        else
            continue;

        if (flag == HIGHER)
          {
            dat = (c << 4) & 0xf0;
            flag = LOWER;
          }
        else
          {
            dat += (c & 0x0f);
            flag = HIGHER;
            fputc (dat, d);
          }
      }
    fprintf (stderr, "%s is created.\n", name);
    (void) fclose (s);
    (void) fclose (d);
}
